_ENV = AIContext

function dispatch.ships()

  local planet = best_industry()
  print(empire.name, 'dispatching ships',planet, nkeys(free_planets))

  if not planet
    return 'pass'
  end

  local design_key = choose_ship_production(planet)

  if not design_key
    return 'pass'
  end

  free_planets[planet]=nil

  local design = empire.designs[design_key]
  local specs = design_to_specs(design)

  local cant = planet:cant_build_design(design_key)



  if cant == 'construction_tier'

    local required_tier in design.config_table!
  
    build_best_infrastructure(planet)
    constructed_ships[ design_to_ship(design) ]='building'
    queued_ship_value += specs.hammer_cost + specs.metal_cost
    return

  elseif cant
    return 'pass'
  end


  constructed_ships[ design_to_ship(design) ]='building'
  queued_ship_value += specs.hammer_cost + specs.metal_cost
  order.set_building_design(planet, design_key ) 


end