_ENV = AIContext

--[[
function ship_power_score(ship)
  local attack_value = design_attack_value(ship.s)
  local defence_value = calc_defence_value(ship)

  if is_combat_boarder(ship)
    attack_value += 2*estimated_boarding_crew_damage(ship)
  end

  return attack_value*(1+defence_value)
end
--]]

--[[
local mtype_to_mult = {
  Light=.5,
  Heavy=2,
  Siege=4,
}

function ship_power_score(ship)
  print(ship.design_key)

  if not next | ship.weapons?
    return 0
  end

  local base_score=0
  local weapon_mult=6

  for i, w ; ship.weapons
    local mtype,n in w

    base_score += weapon_mult*(mtype_to_mult[mtype] or 1)*n
  end

  base_score+= ship.structure + ship.armor + (ship.max_shields or 0)

  local mult= 1 - ( (ship.armor_damage or 0 )+(ship.structure_damage or 0) ) / (ship.armor+ship.structure)

  if (ship.carrying_tanks or 0) > 0
    base_score++
  end

  if ship.empire~=empire
    mult=1
  end

  return mult * base_score
end
--]]